import { type QRL } from "@builder.io/qwik";
export interface SearchParamSerializer<T> {
    serialize$: QRL<(value: T | undefined | null) => string | undefined | null>;
    parse$: QRL<(stringValue: string | null) => T | undefined>;
}
export declare const parseAsString: (defaultValue?: string) => SearchParamSerializer<string>;
export declare const parseAsInteger: (defaultValue?: number) => SearchParamSerializer<number>;
export declare const parseAsHex: (defaultValue?: number) => SearchParamSerializer<number>;
export declare const parseAsFloat: (defaultValue?: number) => SearchParamSerializer<number>;
export declare const parseAsBoolean: (defaultValue?: boolean) => SearchParamSerializer<boolean>;
export declare const parseAsTimestamp: (defaultValue?: Date) => SearchParamSerializer<Date>;
export declare const parseAsIsoDateTime: (defaultValue?: Date) => SearchParamSerializer<Date>;
export declare const parseAsDateTimeFormatted: (dateFormat: string, defaultValue?: Date) => SearchParamSerializer<Date>;
export declare const parseAsStringEnum: <Enum extends string>(validEnums: Enum[], defaultValue?: Enum | undefined) => SearchParamSerializer<Enum>;
export declare const parseAsStringLiteral: <Literal extends string>(validLiterals: Literal[], defaultValue?: Literal | undefined) => SearchParamSerializer<Literal>;
export declare const parseAsNumberLiteral: <Literal extends number>(validLiterals: Literal[], defaultValue?: Literal | undefined) => SearchParamSerializer<Literal>;
export declare const parseAsJson: <T>(defaultValue?: T | undefined) => SearchParamSerializer<T>;
